// Code generated by mockery v2.20.0. DO NOT EDIT.

package mocks

import (
	context "context"
	http "net/http"

	mock "github.com/stretchr/testify/mock"

	ubiquity "gitlab.com/Blockdaemon/ubiquity/ubiquity-go-client/v1/pkg/client"
)

// TransactionsAPI is an autogenerated mock type for the TransactionsAPI type
type TransactionsAPI struct {
	mock.Mock
}

// GetTxByHash provides a mock function with given fields: ctx, protocol, network, hash
func (_m *TransactionsAPI) GetTxByHash(ctx context.Context, protocol string, network string, hash string) ubiquity.ApiGetTxByHashRequest {
	ret := _m.Called(ctx, protocol, network, hash)

	var r0 ubiquity.ApiGetTxByHashRequest
	if rf, ok := ret.Get(0).(func(context.Context, string, string, string) ubiquity.ApiGetTxByHashRequest); ok {
		r0 = rf(ctx, protocol, network, hash)
	} else {
		r0 = ret.Get(0).(ubiquity.ApiGetTxByHashRequest)
	}

	return r0
}

// GetTxByHashExecute provides a mock function with given fields: r
func (_m *TransactionsAPI) GetTxByHashExecute(r ubiquity.ApiGetTxByHashRequest) (ubiquity.Tx, *http.Response, error) {
	ret := _m.Called(r)

	var r0 ubiquity.Tx
	var r1 *http.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(ubiquity.ApiGetTxByHashRequest) (ubiquity.Tx, *http.Response, error)); ok {
		return rf(r)
	}
	if rf, ok := ret.Get(0).(func(ubiquity.ApiGetTxByHashRequest) ubiquity.Tx); ok {
		r0 = rf(r)
	} else {
		r0 = ret.Get(0).(ubiquity.Tx)
	}

	if rf, ok := ret.Get(1).(func(ubiquity.ApiGetTxByHashRequest) *http.Response); ok {
		r1 = rf(r)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*http.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(ubiquity.ApiGetTxByHashRequest) error); ok {
		r2 = rf(r)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// GetTxConfirmations provides a mock function with given fields: ctx, protocol, network, hash
func (_m *TransactionsAPI) GetTxConfirmations(ctx context.Context, protocol string, network string, hash string) ubiquity.ApiGetTxConfirmationsRequest {
	ret := _m.Called(ctx, protocol, network, hash)

	var r0 ubiquity.ApiGetTxConfirmationsRequest
	if rf, ok := ret.Get(0).(func(context.Context, string, string, string) ubiquity.ApiGetTxConfirmationsRequest); ok {
		r0 = rf(ctx, protocol, network, hash)
	} else {
		r0 = ret.Get(0).(ubiquity.ApiGetTxConfirmationsRequest)
	}

	return r0
}

// GetTxConfirmationsExecute provides a mock function with given fields: r
func (_m *TransactionsAPI) GetTxConfirmationsExecute(r ubiquity.ApiGetTxConfirmationsRequest) (ubiquity.TxConfirmation, *http.Response, error) {
	ret := _m.Called(r)

	var r0 ubiquity.TxConfirmation
	var r1 *http.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(ubiquity.ApiGetTxConfirmationsRequest) (ubiquity.TxConfirmation, *http.Response, error)); ok {
		return rf(r)
	}
	if rf, ok := ret.Get(0).(func(ubiquity.ApiGetTxConfirmationsRequest) ubiquity.TxConfirmation); ok {
		r0 = rf(r)
	} else {
		r0 = ret.Get(0).(ubiquity.TxConfirmation)
	}

	if rf, ok := ret.Get(1).(func(ubiquity.ApiGetTxConfirmationsRequest) *http.Response); ok {
		r1 = rf(r)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*http.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(ubiquity.ApiGetTxConfirmationsRequest) error); ok {
		r2 = rf(r)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// GetTxOutputByHashAndIndex provides a mock function with given fields: ctx, protocol, network, hash, index
func (_m *TransactionsAPI) GetTxOutputByHashAndIndex(ctx context.Context, protocol string, network string, hash string, index int32) ubiquity.ApiGetTxOutputByHashAndIndexRequest {
	ret := _m.Called(ctx, protocol, network, hash, index)

	var r0 ubiquity.ApiGetTxOutputByHashAndIndexRequest
	if rf, ok := ret.Get(0).(func(context.Context, string, string, string, int32) ubiquity.ApiGetTxOutputByHashAndIndexRequest); ok {
		r0 = rf(ctx, protocol, network, hash, index)
	} else {
		r0 = ret.Get(0).(ubiquity.ApiGetTxOutputByHashAndIndexRequest)
	}

	return r0
}

// GetTxOutputByHashAndIndexExecute provides a mock function with given fields: r
func (_m *TransactionsAPI) GetTxOutputByHashAndIndexExecute(r ubiquity.ApiGetTxOutputByHashAndIndexRequest) (ubiquity.TxOutput, *http.Response, error) {
	ret := _m.Called(r)

	var r0 ubiquity.TxOutput
	var r1 *http.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(ubiquity.ApiGetTxOutputByHashAndIndexRequest) (ubiquity.TxOutput, *http.Response, error)); ok {
		return rf(r)
	}
	if rf, ok := ret.Get(0).(func(ubiquity.ApiGetTxOutputByHashAndIndexRequest) ubiquity.TxOutput); ok {
		r0 = rf(r)
	} else {
		r0 = ret.Get(0).(ubiquity.TxOutput)
	}

	if rf, ok := ret.Get(1).(func(ubiquity.ApiGetTxOutputByHashAndIndexRequest) *http.Response); ok {
		r1 = rf(r)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*http.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(ubiquity.ApiGetTxOutputByHashAndIndexRequest) error); ok {
		r2 = rf(r)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// GetTxs provides a mock function with given fields: ctx, protocol, network
func (_m *TransactionsAPI) GetTxs(ctx context.Context, protocol string, network string) ubiquity.ApiGetTxsRequest {
	ret := _m.Called(ctx, protocol, network)

	var r0 ubiquity.ApiGetTxsRequest
	if rf, ok := ret.Get(0).(func(context.Context, string, string) ubiquity.ApiGetTxsRequest); ok {
		r0 = rf(ctx, protocol, network)
	} else {
		r0 = ret.Get(0).(ubiquity.ApiGetTxsRequest)
	}

	return r0
}

// GetTxsExecute provides a mock function with given fields: r
func (_m *TransactionsAPI) GetTxsExecute(r ubiquity.ApiGetTxsRequest) (ubiquity.TxPage, *http.Response, error) {
	ret := _m.Called(r)

	var r0 ubiquity.TxPage
	var r1 *http.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(ubiquity.ApiGetTxsRequest) (ubiquity.TxPage, *http.Response, error)); ok {
		return rf(r)
	}
	if rf, ok := ret.Get(0).(func(ubiquity.ApiGetTxsRequest) ubiquity.TxPage); ok {
		r0 = rf(r)
	} else {
		r0 = ret.Get(0).(ubiquity.TxPage)
	}

	if rf, ok := ret.Get(1).(func(ubiquity.ApiGetTxsRequest) *http.Response); ok {
		r1 = rf(r)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*http.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(ubiquity.ApiGetTxsRequest) error); ok {
		r2 = rf(r)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// TxCreate provides a mock function with given fields: ctx, protocol, network
func (_m *TransactionsAPI) TxCreate(ctx context.Context, protocol string, network string) ubiquity.ApiTxCreateRequest {
	ret := _m.Called(ctx, protocol, network)

	var r0 ubiquity.ApiTxCreateRequest
	if rf, ok := ret.Get(0).(func(context.Context, string, string) ubiquity.ApiTxCreateRequest); ok {
		r0 = rf(ctx, protocol, network)
	} else {
		r0 = ret.Get(0).(ubiquity.ApiTxCreateRequest)
	}

	return r0
}

// TxCreateExecute provides a mock function with given fields: r
func (_m *TransactionsAPI) TxCreateExecute(r ubiquity.ApiTxCreateRequest) (ubiquity.UnsignedTx, *http.Response, error) {
	ret := _m.Called(r)

	var r0 ubiquity.UnsignedTx
	var r1 *http.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(ubiquity.ApiTxCreateRequest) (ubiquity.UnsignedTx, *http.Response, error)); ok {
		return rf(r)
	}
	if rf, ok := ret.Get(0).(func(ubiquity.ApiTxCreateRequest) ubiquity.UnsignedTx); ok {
		r0 = rf(r)
	} else {
		r0 = ret.Get(0).(ubiquity.UnsignedTx)
	}

	if rf, ok := ret.Get(1).(func(ubiquity.ApiTxCreateRequest) *http.Response); ok {
		r1 = rf(r)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*http.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(ubiquity.ApiTxCreateRequest) error); ok {
		r2 = rf(r)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

// TxSend provides a mock function with given fields: ctx, protocol, network
func (_m *TransactionsAPI) TxSend(ctx context.Context, protocol string, network string) ubiquity.ApiTxSendRequest {
	ret := _m.Called(ctx, protocol, network)

	var r0 ubiquity.ApiTxSendRequest
	if rf, ok := ret.Get(0).(func(context.Context, string, string) ubiquity.ApiTxSendRequest); ok {
		r0 = rf(ctx, protocol, network)
	} else {
		r0 = ret.Get(0).(ubiquity.ApiTxSendRequest)
	}

	return r0
}

// TxSendExecute provides a mock function with given fields: r
func (_m *TransactionsAPI) TxSendExecute(r ubiquity.ApiTxSendRequest) (ubiquity.TxReceipt, *http.Response, error) {
	ret := _m.Called(r)

	var r0 ubiquity.TxReceipt
	var r1 *http.Response
	var r2 error
	if rf, ok := ret.Get(0).(func(ubiquity.ApiTxSendRequest) (ubiquity.TxReceipt, *http.Response, error)); ok {
		return rf(r)
	}
	if rf, ok := ret.Get(0).(func(ubiquity.ApiTxSendRequest) ubiquity.TxReceipt); ok {
		r0 = rf(r)
	} else {
		r0 = ret.Get(0).(ubiquity.TxReceipt)
	}

	if rf, ok := ret.Get(1).(func(ubiquity.ApiTxSendRequest) *http.Response); ok {
		r1 = rf(r)
	} else {
		if ret.Get(1) != nil {
			r1 = ret.Get(1).(*http.Response)
		}
	}

	if rf, ok := ret.Get(2).(func(ubiquity.ApiTxSendRequest) error); ok {
		r2 = rf(r)
	} else {
		r2 = ret.Error(2)
	}

	return r0, r1, r2
}

type mockConstructorTestingTNewTransactionsAPI interface {
	mock.TestingT
	Cleanup(func())
}

// NewTransactionsAPI creates a new instance of TransactionsAPI. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewTransactionsAPI(t mockConstructorTestingTNewTransactionsAPI) *TransactionsAPI {
	mock := &TransactionsAPI{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
